umbrello 25.08.1 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
CsValaImportBase Class Reference

`#include <csvalaimportbase.h>`

Inheritance diagram for CsValaImportBase:

## Public Member Functions
| CsValaImportBase (CodeImpThread *thread=nullptr)
virtual | ~CsValaImportBase ()
Public Member Functions inherited from JavaCsValaImportBase
| JavaCsValaImportBase (CodeImpThread *thread=nullptr)
virtual | ~JavaCsValaImportBase ()
virtual QString | fileExtension ()=0
Public Member Functions inherited from NativeImportBase
| NativeImportBase (const QString &singleLineCommentIntro, CodeImpThread *thread=nullptr)
virtual | ~NativeImportBase ()
Public Member Functions inherited from ClassImport
| ClassImport (CodeImpThread *thread=nullptr)
virtual | ~ClassImport ()
bool | importFiles (const QStringList &fileNames)
bool | importFile (const QString &fileName)
void | setRootPath (const QString &path)
bool | enabled () const

## Protected Member Functions
bool | parseStmt ()
bool | preprocess (QString &line)
Protected Member Functions inherited from JavaCsValaImportBase
void | initVars ()
void | fillSource (const QString &word)
bool | parseFile (const QString &filename)
virtual void | spawnImport (const QString &file)=0
UMLObject * | resolveClass (const QString &className)
QString | joinTypename (const QString &typeName)
bool | parseClassDeclaration (const QString &keyword)
bool | parseEnumDeclaration ()
Protected Member Functions inherited from NativeImportBase
void | initialize ()
void | setMultiLineComment (const QString &intro, const QString &end)
void | setMultiLineAltComment (const QString &intro, const QString &end)
void | scan (const QString &line)
virtual QStringList | split (const QString &line)
void | skipStmt (const QString &until=QStringLiteral(";"))
bool | skipToClosing (QChar opener)
QString | current ()
QString | lookAhead ()
virtual QString | advance ()
void | pushScope (UMLPackage *p)
UMLPackage * | popScope ()
UMLPackage * | currentScope ()
int | scopeIndex ()
Protected Member Functions inherited from ClassImport
virtual void | initPerFile ()
void | log (const QString &file, const QString &text)
void | log (const QString &text)

## Private Member Functions
bool | parseUsingDirectives ()
bool | parseGlobalAttributes ()
bool | parseNamespaceDeclaration ()
bool | parseAnnotation ()
bool | parseClassDeclaration (const QString &keyword)
bool | parseStructDeclaration ()
bool | parseEnumDeclaration ()
bool | parseDelegateDeclaration ()
bool | isTypeDeclaration (const QString &keyword)
bool | isClassModifier (const QString &keyword)
bool | isCommonModifier (const QString &keyword)

## Additional Inherited Members
Static Public Member Functions inherited from ClassImport
static ClassImport * | createImporterByFileExt (const QString &fileName, CodeImpThread *thread=nullptr)
Static Protected Member Functions inherited from JavaCsValaImportBase
static UMLObject * | findObject (const QString &name, UMLPackage *parentPkg)
Protected Attributes inherited from JavaCsValaImportBase
bool | m_isStatic
| static flag for the member var or method
QString | m_currentFileName
| current filename being parsed
QString | m_currentPackage
| current package of the file being parsed
QStringList | m_imports
| imports included in the current file
Uml::Visibility::Enum | m_defaultCurrentAccess
| current visibility for when the visibility is absent
Uml::ProgrammingLanguage::Enum | m_language
Protected Attributes inherited from NativeImportBase
QString | m_singleLineCommentIntro
| start token of a single line comment
QStringList | m_source
| the scanned lexemes
int | m_srcIndex
| used for indexing m_source
QList< UMLPackage * > | m_scope
| stack of scopes for use by the specific importer
UMLClassifier * | m_klass
| class currently being processed
Uml::Visibility::Enum | m_currentAccess
| current access (public/protected/private)
QString | m_comment
| intermediate accumulator for comment text
bool | m_inComment
bool | m_isAbstract
| accumulator for abstractness
QString | m_multiLineCommentIntro
| multi line comment delimiter intro
QString | m_multiLineCommentEnd
| multi line comment delimiter end
QString | m_multiLineAltCommentIntro
QString | m_multiLineAltCommentEnd
Protected Attributes inherited from ClassImport
CodeImpThread * | m_thread
| thread in which the work of importing is done
bool | m_enabled
| state of importer
QString | m_rootPath
| root path of import
Static Protected Attributes inherited from JavaCsValaImportBase
static QStringList | s_filesAlreadyParsed
static int | s_parseDepth = 0
Static Protected Attributes inherited from NativeImportBase
static QStringList | m_parsedFiles

## Detailed Description

Base class for C# and Vala code import.

Author
  Oliver Kellogg
  Andi Fischer (copied from JavaImport) Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ CsValaImportBase()

CsValaImportBase::CsValaImportBase | ( | CodeImpThread * | thread = nullptr | ) |
| inline explicit

## ◆ ~CsValaImportBase()

virtual CsValaImportBase::~CsValaImportBase | ( |  | ) |
| inline virtual

## Member Function Documentation

## ◆ isClassModifier()

bool CsValaImportBase::isClassModifier | ( | const QString & | keyword | ) |
| private

Check if keyword is a class-modifier.

Returns
  result of check

## ◆ isCommonModifier()

bool CsValaImportBase::isCommonModifier | ( | const QString & | keyword | ) |
| private

Check if keyword is an interface, struct, enum or delegate modifier.

Returns
  result of check

## ◆ isTypeDeclaration()

bool CsValaImportBase::isTypeDeclaration | ( | const QString & | keyword | ) |
| private

Check if keyword is belonging to a type-declaration.

Returns
  result of check

## ◆ parseAnnotation()

bool CsValaImportBase::parseAnnotation | ( |  | ) |
| private

Parsing attributes.

Returns
  success status of parsing

## ◆ parseClassDeclaration()

bool CsValaImportBase::parseClassDeclaration | ( | const QString & | keyword | ) |
| private

Parsing the statement 'class' or 'interface'.

Returns
  success status of parsing

## ◆ parseDelegateDeclaration()

bool CsValaImportBase::parseDelegateDeclaration | ( |  | ) |
| private

Parsing a delegate-declaration.

Returns
  success status of parsing

## ◆ parseEnumDeclaration()

bool CsValaImportBase::parseEnumDeclaration | ( |  | ) |
| private

Parsing the statement 'enum'.

Returns
  success status of parsing

## ◆ parseGlobalAttributes()

bool CsValaImportBase::parseGlobalAttributes | ( |  | ) |
| private

Parsing global attributes.

Returns
  success status of parsing

## ◆ parseNamespaceDeclaration()

bool CsValaImportBase::parseNamespaceDeclaration | ( |  | ) |
| private

Parsing the statement 'namespace'.

Returns
  success status of parsing

## ◆ parseStmt()

bool CsValaImportBase::parseStmt | ( |  | ) |
| protected virtual

Implement abstract operation from NativeImportBase. compilation-unit: using-directives? global-attributes? namespace-member-declarations?

Returns
  success status of operation

Implements NativeImportBase.

## ◆ parseStructDeclaration()

bool CsValaImportBase::parseStructDeclaration | ( |  | ) |
| private

Parsing a struct-declaration.

Returns
  success status of parsing

## ◆ parseUsingDirectives()

bool CsValaImportBase::parseUsingDirectives | ( |  | ) |
| private

Parsing the statement 'using'. Keep track of imports so we can resolve classes we are dependent on.

Returns
  success status of parsing

## ◆ preprocess()

bool CsValaImportBase::preprocess | ( | QString & | line | ) |
| protected virtual

Override operation from NativeImportBase.

Reimplemented from NativeImportBase.

The documentation for this class was generated from the following files:

- umbrello/codeimport/csvalaimportbase.h
- umbrello/codeimport/csvalaimportbase.cpp